#include <kos.h>
#include "input.h"
#include "screen.h"

int echo=1;
int keyblock=1;
float kbtm=0;
int show_cursor=1;

void set_show_cursor(int state) { show_cursor=state; }
void set_echo(int state) { echo=state; }
void set_keyblock(int state) { keyblock=state; }
void set_timeout(int tm) { 
  uint32 s,ms;
  timer_ms_gettime(&s,&ms);
  if(tm==0) kbtm=0; else kbtm=s*1000+ms+(tm*100); 
}
void get_string(char *buf) {
}

void c99_mouse_init() {}
void read_mouse(int *x, int *y, int *lmb) {
  mouse_cond_t mcond;
  cont_state_t *ccond;
  uint8 mmouse=maple_first_mouse();
  maple_device_t *caddr=maple_enum_dev(0,0);

  if(caddr) {
    ccond=(cont_state_t*)maple_dev_status(caddr);
    *x+=ccond->joyx/8;
    *y+=ccond->joyy/8;
    if((ccond->buttons & CONT_A)) {
      *lmb=1;
      return;
    }
  }

  if(mmouse) {
    if (mouse_get_cond(mmouse, &mcond) < 0) return;
    *x+=mcond.dx;
    *y+=mcond.dy;
    if(!(mcond.buttons & MOUSE_LEFTBUTTON)) *lmb=1; else *lmb=0;
  }
}

char getch() {
  int cx,cy;
  int i=0;
  uint32 s,ms,tm;
  char x;
  getxy(&cx,&cy);
  timer_ms_gettime(&s,&ms);
  tm=s*1000+ms;
  do {
    i++;
    if(show_cursor) {
      if(i<10) { locate(cx,cy); c99_printf("_"); locate(cx,cy); }
      if(i>10) { locate(cx,cy); c99_printf(" "); locate(cx,cy); }
      if(i>20) { i=0; }
      video_refresh();
    }
    x=kbd_get_key();
    switch(poll_game_device(0)) {
      case MOVE_UP: x= 129; break;
      case MOVE_DOWN: x= 130; break;
      case MOVE_LEFT: x= 131; break;
      case MOVE_RIGHT: x= 132; break;
    }
    timer_ms_gettime(&s,&ms);
    if(kbtm>0 && (s*1000+ms > kbtm)) {
      x=0; break;
    }
  } while(keyblock&&(x==0||x==-1));
  if(show_cursor) { locate(cx,cy); c99_printf(" "); locate(cx,cy); }
  if(echo) c99_printf("%c",x);
  return x;
}

int poll_game_device(int num) {
  maple_device_t *caddr=maple_enum_dev(num,0);
  maple_device_t *keyb=maple_enum_type(0,MAPLE_FUNC_KEYBOARD);
  kbd_state_t *state;
  cont_state_t *cont;

  if(keyb) {
    state=(kbd_state_t *)maple_dev_status(keyb);
    if(state->matrix[KBD_KEY_UP]) {
      return MOVE_UP; 
    }
    if(state->matrix[KBD_KEY_DOWN]) {
      return MOVE_DOWN; 
    }
    if(state->matrix[KBD_KEY_LEFT]) {
      return MOVE_LEFT; 
    }
    if(state->matrix[KBD_KEY_RIGHT]) {
      return MOVE_RIGHT; 
    }
    if(state->matrix[KBD_KEY_ENTER]) {
      return START_BTN; 
    }
  }

  if(caddr==NULL) return -1;
  cont=(cont_state_t*)maple_dev_status(caddr);

  if(cont->buttons & CONT_DPAD_UP) {
    return MOVE_UP;
  }
  if(cont->buttons & CONT_DPAD_DOWN) {
    return MOVE_DOWN;
  }
  if(cont->buttons & CONT_DPAD_LEFT) {
    return MOVE_LEFT;
  }
  if(cont->buttons & CONT_DPAD_RIGHT) {
    return MOVE_RIGHT;
  }
  if(cont->buttons & CONT_A) {
    return FIRE_BTN;
  }
  if(cont->buttons & CONT_B) {
    return QUIT_BTN;
  }
  if(cont->buttons & CONT_X) {
    return BUTTON_X;
  }
  if(cont->buttons & CONT_Y) {
    //vid_screen_shot("/pc/home/chip/sshot.ppm");
    return BUTTON_Y;
  }
  if(cont->buttons & CONT_START) {
    return START_BTN;
  }
  return 0;
}
