#include <kos.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include "sys.h"

//extern uint8 romdisk[];

KOS_INIT_FLAGS(INIT_DEFAULT/*|INIT_MALLOCSTATS*/);
//KOS_INIT_ROMDISK(romdisk);

pvr_init_params_t params = {
        /* Enable opaque and translucent polygons with size 16 */
        { PVR_BINSIZE_16, PVR_BINSIZE_0, PVR_BINSIZE_16, PVR_BINSIZE_0, PVR_BINSIZE_0 },
        /* Vertex buffer size 512K */
        512*1024
};

void delay(float seconds) {
  uint32 s,ms,tm;
  timer_ms_gettime(&s,&ms);
  tm=(s*1000)+ms;
  do {
    timer_ms_gettime(&s,&ms);
  } while ((s*1000)+ms < tm + (seconds*1000));
}

void sys_init(char *title) { 
  pvr_init(&params);
	glKosInit();
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0f, 640.0f / 480.0f, 0.1f, 100.0f);
	glMatrixMode(GL_MODELVIEW);
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_KOS_AUTO_UV);
	glDisable(GL_CULL_FACE);
        glShadeModel(GL_SMOOTH);
        glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(0,640,480,0,1,-1);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}

bool sys_render_begin() {
  glKosBeginFrame();
  return 1;
}

void sys_render_finish() {
  glKosFinishFrame();
}
