#ifdef WIN32
#include <windows.h>
#endif
#ifdef DREAMCAST
#include <kos.h>
#endif
#include <GL/gl.h>
#include <GL/glu.h>
#include "font.h"
#include "screen.h"
#include "sys.h"
#include "stream.h"
#include "input.h"
#include "window.h"

void doneClicked(int win_id, int but_id) {
#ifdef DREAMCAST
  arch_exit();
#else
  exit(0);
#endif
}

int w,l,i,b;

void listChanged(int win_id, int list_id) {
  C99ListBox *current=get_list(win_id,list_id);
  if(current->sel>=0) {
    set_inputbox_text(win_id,i,current->items[current->sel]);
  } else {
    set_inputbox_text(win_id,i,"");
  }
}

int main() {
  int x;
  float rot=0;
  char buf[100];
#ifdef DREAMCAST
  fs_chdir("/cd");
#endif

  //set up the OpenGL window with a title of "c99test"
  sys_init("c99test");

  //put OpenGL into a 2d-ish mode
  //top left = 0,0
  //bottom right = 640,480
#ifdef WIN32
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(0,640,480,0,-1,1);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
#endif
  //initialize the text library
  load_font("hybrid.fnt");
  init_screen();
  c99_mouse_init();
  c99_resize_screen(80,25,8,16);
  set_border(6);

  //white on black
  color(1,6);
  clear_screen();

  w=c99_create_window(320-((32*get_font_width()+4)/2),10,32*get_font_width()+4,372,"Select a File");
  l=c99_create_list(w,2,2,32*get_font_width(),324);
  c99_list_set_changed(w,l,listChanged);
  c99_list_add_item(w,l,"../");
  c99_list_add_item(w,l,"Advent.z5");
  c99_list_add_item(w,l,"hhgg.z5");
  c99_list_add_item(w,l,"sherlo.dat");
  c99_list_add_item(w,l,"cat.dat");
  c99_list_add_item(w,l,"taco.dat");
  c99_list_add_item(w,l,"Advent.z5");
  c99_list_add_item(w,l,"hhgg.z5");
  c99_list_add_item(w,l,"sherlo.dat");
  c99_list_add_item(w,l,"cat.dat");
  c99_list_add_item(w,l,"taco.dat");
  c99_list_add_item(w,l,"Advent.z5");
  c99_list_add_item(w,l,"hhgg.z5");
  c99_list_add_item(w,l,"sherlo.dat");
  c99_list_add_item(w,l,"cat.dat");
  c99_list_add_item(w,l,"taco.dat");
  c99_list_add_item(w,l,"Advent.z5");
  c99_list_add_item(w,l,"hhgg.z5");
  c99_list_add_item(w,l,"sherlo.dat");
  c99_list_add_item(w,l,"cat.dat");
  c99_list_add_item(w,l,"taco.dat");
  c99_list_add_item(w,l,"Advent.z5");
  c99_list_add_item(w,l,"hhgg.z5");
  c99_list_add_item(w,l,"sherlo.dat");
  c99_list_add_item(w,l,"cat.dat");
  c99_list_add_item(w,l,"taco.dat");
  i=c99_create_inputbox(w,2,328,24*get_font_width(),20,"Advent.z5");
  b=c99_create_button(w,24*get_font_width()+4,328,7*get_font_width()+(get_font_width()-2),20,"Load");
  set_button_click(w,b,doneClicked);
  c99_create_button(w,2,350,(32*get_font_width()-4)/3,20,"VMU");
  c99_create_button(w,4+((32*get_font_width()-4)/3)*1,350,(32*get_font_width()-4)/3,20,"CD-ROM");
  c99_create_button(w,6+((32*get_font_width()-4)/3)*2,350,(32*get_font_width()-4)/3,20,"PC");

  do {
    if(sys_render_begin()) { //make sure it's ok to draw (are we minimized?)
      glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
      //draw the text layer
      render_screen();
      render_windows();
      sys_render_finish();
    }
  } while(1);
  return 0;
}


