#include <windows.h>
#include <GL\gl.h>
#include <dinput.h>
#include <stdio.h>
#include "sys.h"
#include "screen.h"
#include "input.h"

extern bool keys[256];
LPDIRECTINPUT8       g_pDI    = NULL;         
LPDIRECTINPUTDEVICE8 g_pMouse = NULL;     
int echo=1;
int keyblock=1;
int kbtm=0;

void set_echo(int state) { echo=state; }
void set_keyblock(int state) { keyblock=state; }
void set_timeout(int tm) { kbtm=tm; }
void set_show_cursor(int state) { }

extern HWND hWnd;

void read_mouse(int *x, int *y, int *lmb) {
    HRESULT       hr;
    DIMOUSESTATE2 dims2;      // DirectInput mouse state structure

    if( NULL == g_pMouse ) 
        return;
    
    // Get the input's device state, and put the state in dims
    ZeroMemory( &dims2, sizeof(dims2) );
    hr = g_pMouse->GetDeviceState( sizeof(DIMOUSESTATE2), &dims2 );
    if( FAILED(hr) ) 
    {
        // DirectInput may be telling us that the input stream has been
        // interrupted.  We aren't tracking any state between polls, so
        // we don't have any special reset that needs to be done.
        // We just re-acquire and try again.
        
        // If input is lost then acquire and keep trying 
        hr = g_pMouse->Acquire();
        while( hr == DIERR_INPUTLOST ) 
            hr = g_pMouse->Acquire();

        return; 
    }
    
    // The dims structure now has the state of the mouse, so 
    // display mouse coordinates (x, y, z) and buttons.
    *x+=dims2.lX;
    *y+=dims2.lY;
    *lmb=dims2.rgbButtons[0];
/*                        (dims2.rgbButtons[0] & 0x80) ? '1' : '0',
                        (dims2.rgbButtons[1] & 0x80) ? '1' : '0',
                        (dims2.rgbButtons[2] & 0x80) ? '1' : '0',
                        (dims2.rgbButtons[3] & 0x80) ? '1' : '0',
                        (dims2.rgbButtons[4] & 0x80) ? '1' : '0',
                        (dims2.rgbButtons[5] & 0x80) ? '1' : '0',
                        (dims2.rgbButtons[6] & 0x80) ? '1' : '0',
                        (dims2.rgbButtons[7] & 0x80) ? '1' : '0');*/
}

void c99_mouse_init() {
    HRESULT hr;
    DWORD   dwCoopFlags;

    dwCoopFlags = DISCL_EXCLUSIVE;
    dwCoopFlags |= DISCL_FOREGROUND;

    // Create a DInput object
    if( FAILED( hr = DirectInput8Create( GetModuleHandle(NULL), DIRECTINPUT_VERSION, 
                                         IID_IDirectInput8, (VOID**)&g_pDI, NULL ) ) )
        return;
    
    // Obtain an interface to the system mouse device.
    if( FAILED( hr = g_pDI->CreateDevice( GUID_SysMouse, &g_pMouse, NULL ) ) )
        return;
    
    // Set the data format to "mouse format" - a predefined data format 
    //
    // A data format specifies which controls on a device we
    // are interested in, and how they should be reported.
    //
    // This tells DirectInput that we will be passing a
    // DIMOUSESTATE2 structure to IDirectInputDevice::GetDeviceState.
    if( FAILED( hr = g_pMouse->SetDataFormat( &c_dfDIMouse2 ) ) )
        return;
    
    // Set the cooperativity level to let DirectInput know how
    // this device should interact with the system and with other
    // DirectInput applications.
    hr = g_pMouse->SetCooperativeLevel( hWnd, dwCoopFlags );

    if( FAILED(hr) )
        return;

    // Acquire the newly created device
    g_pMouse->Acquire();
}

void get_string(char *buf) {
  int i,j;
  char x;
  int y=0;
  do {
    getxy(&i,&j);
    if(sys_render_begin()) {
      glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
      render_screen();
      sys_render_finish();
    }
    x=getch();
    if(sys_render_begin()) {
      glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
      render_screen();
      sys_render_finish();
    }

    if(x==13) {
      buf[y]='\0';
      break;
    }else if(x==8) {
      if(y>0) {
        y--;
        locate(i-1,j);
        c99_printf(" ");
        locate(i-1,j);
        printf("%i\n",y);
      }
    } else {
      printf("%i\n",y);
      buf[y]=x;
      y++;
    }
  } while(x!=13);
}

char getch() {
  int x,y=0;
  do {
    if(sys_render_begin()) {
      for(x=0;x<255;x++) {
        if(keys[x]==1&&x!=VK_SHIFT) {
          y=x;
          keys[x]=0;
          if((x>='A' && x<='Z')) {
            if(keys[VK_SHIFT]==0) {
              y=x+32;
            }
          }
          if(keys[VK_SHIFT]==1) {
            switch(x) {
              case '0':
                y=')';
                break;
              case '1':
                y='!';
                break;
              case '2':
                y='@';
                break;
              case '3':
                y='#';
                break;
              case '4':
                y='$';
                break;
              case '5':
                y='%';
                break;
              case '6':
                y='^';
                break;
              case '7':
                y='&';
                break;
              case '8':
                y='*';
                break;
              case '9':
                y='(';
                break;
/*              case VK_MINUS:
                y='_';
                break;
              case VK_EQUALS:
                y='+';
                break;*/
              case '[':
                y='{';
                break;
              case ']':
                y='}';
                break;
              case '\\':
                y='|';
                break;
              case ';':
                y=':';
                break;
              case '\'':
                y='\"';
                break;
              case ',':
                y='<';
                break;
              case '.':
                y='>';
                break;
            }
          }
          if(echo&&y!=13&&y!=8)
          c99_printf("%c",y);
          return y;
        }
      }
      //glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
      //render_screen();
      sys_render_finish();
    }
  } while(keyblock);
  return 0;
}

int poll_game_device(int num) {
  sys_render_begin();
  if (keys[VK_RETURN]) {
		return START_BTN;
  } else if (keys[VK_ESCAPE]) {
    return QUIT_BTN;
  } else if (keys[VK_SPACE]) {
    return FIRE_BTN;
  }
	switch(num) {
	case 0:
    if (keys[VK_LEFT]) {
      return MOVE_LEFT;
		}
		else if (keys[VK_RIGHT]) {
      return MOVE_RIGHT;
    }
    else if (keys[VK_UP]) {
      return MOVE_UP;
    }
    else if (keys[VK_DOWN]) {
      return MOVE_DOWN;
    }
		break;
	case 1:
		if(keys['A']) {
			return MOVE_LEFT;
		}
		else if (keys['D']) {
			return MOVE_RIGHT;
		}
		else if (keys['W']) {
			return MOVE_UP;
		}
		else if (keys['S']) {
			return MOVE_DOWN;
		}
		break;
	}
	return 0;
}
