#include <string.h>
#ifdef DREAMCAST
#include <kos.h>
#include <GL/gl.h>
#else
#include <windows.h>
#include <GL\gl.h>
#endif
#include <malloc.h>
#include "window.h"
#include "font.h"
#include "input.h"

int next_but_id=0;

int c99_create_button(int win_id, int x, int y, int xsize, int ysize, char *label) {
  struct C99Window *current_win=get_window(win_id);
  struct C99Button *current=current_win->button_list;
  struct C99Button *prev=NULL;
  while(current) {
    prev=current;
    current=current->next;
  }
  current=(struct C99Button*)malloc(sizeof(C99Button));
  current->x=x;
  current->y=y;
  current->but_id=next_but_id;
  current->win_id=win_id;
  current->highlight=0;
  current->def=0;
  current->xsize=xsize;
  current->ysize=ysize;
  current->label=(char *)malloc(strlen(label)+1);
  current->next=NULL;
  current->onClick=NULL;
  strcpy(current->label,label);
  if(prev) {
    prev->next=current;
  } else {
    current_win->button_list=current;
  }
  return next_but_id++;
}

struct C99Button *get_button(int win_id, int but_id) {
  struct C99Window *cur_win=get_window(win_id);
  struct C99Button *current=cur_win->button_list;

  while(current) {
    if(current->but_id==but_id) return current;
    current=current->next;
  }

  return NULL;
}

void c99_button_set_def(int win_id, int but_id) {
  struct C99Button *current=get_button(win_id,but_id); 
  current->def=1;
}

void c99_draw_button(struct C99Button *current) {
  if(current->def==1&&poll_game_device(0)==START_BTN) current->highlight=1;

  glDisable(GL_TEXTURE_2D);
  glColor3f(0,0,0);
  glBegin(GL_QUADS);
  glVertex3f(current->x,current->y,0);
  glVertex3f(current->x+current->xsize,current->y,0);
  glVertex3f(current->x+current->xsize,current->y+current->ysize,0);
  glVertex3f(current->x,current->y+current->ysize,0);
  glEnd();
  if(current->highlight==0) {
    glColor3f(1,1,1);
  }
  glBegin(GL_QUADS);
  glVertex3f(current->x+2,current->y+2,0.01);
  glVertex3f(current->x+current->xsize-2,current->y+2,0.01);
  glVertex3f(current->x+current->xsize-2,current->y+current->ysize-2,0.01);
  glVertex3f(current->x+2,current->y+current->ysize-2,0.01);
  glEnd();
  glEnable(GL_TEXTURE_2D);
  if(current->highlight==0) {
    glColor3f(0,0,0);
  } else {
    glColor3f(1,1,1);
  }
  draw_string(current->label,current->x+((current->xsize/2.0f)-(strlen(current->label)*get_font_width())/2.0f),current->y+2,0.1);
}

void set_button_click(int win_id, int but_id, button_click_callback onClick) {
  struct C99Button *current=get_button(win_id, but_id);
  current->onClick=onClick;
}