#include <string.h>
#ifdef DREAMCAST
#include <kos.h>
#include <GL/gl.h>
#else
#include <windows.h>
#include <GL\gl.h>
#endif
#include <malloc.h>
#include "window.h"
#include "font.h"
#include "input.h"

int next_inputbox_id=0;

int c99_create_inputbox(int win_id, int x, int y, int xsize, int ysize, char *label) {
  struct C99Window *current_win=get_window(win_id);
  struct C99InputBox *current=current_win->inputbox_list;
  struct C99InputBox *prev=NULL;
  while(current) {
    prev=current;
    current=current->next;
  }
  current=(struct C99InputBox*)malloc(sizeof(struct C99InputBox));
  current->x=x;
  current->y=y;
  current->but_id=next_inputbox_id;
  current->win_id=win_id;
  current->xsize=xsize;
  current->ysize=ysize;
  current->pos=strlen(label);
  current->cur=0;
  current->next=NULL;
  current->onClick=NULL;
  strcpy(current->label,label);
  if(prev) {
    prev->next=current;
  } else {
    current_win->inputbox_list=current;
  }
  return next_inputbox_id++;
}

C99InputBox *get_inputbox(int win_id, int but_id) {
  C99Window *cur_win=get_window(win_id);
  C99InputBox *current=cur_win->inputbox_list;

  while(current) {
    if(current->but_id==but_id) return current;
    current=current->next;
  }

  return NULL;
}

void c99_update_inputbox(struct C99InputBox *current) {
  char c;
  int x;

  set_keyblock(0);
  c=getch();
  set_keyblock(1);

  if(c>0) {
    x=strlen(current->label);
    if(c>=32 && c <= 176) {
      current->label[x]=c;
      current->label[x+1]='\0';
    } else if (c==8 && x>0) {
      current->label[x-1]='\0';
    }

  }
}

void c99_draw_inputbox(C99InputBox *current) {
  glDisable(GL_TEXTURE_2D);
  glColor3f(0,0,0);
  glBegin(GL_QUADS);
  glVertex3f(current->x,current->y,0);
  glVertex3f(current->x+current->xsize,current->y,0);
  glVertex3f(current->x+current->xsize,current->y+current->ysize,0);
  glVertex3f(current->x,current->y+current->ysize,0);
  glEnd();
  glColor3f(1,1,1);
  glBegin(GL_QUADS);
  glVertex3f(current->x+2,current->y+2,0.01);
  glVertex3f(current->x+current->xsize-2,current->y+2,0.01);
  glVertex3f(current->x+current->xsize-2,current->y+current->ysize-2,0.01);
  glVertex3f(current->x+2,current->y+current->ysize-2,0.01);
  glEnd();
  glEnable(GL_TEXTURE_2D);
  glColor3f(0,0,0);
  draw_string(current->label,current->x+2,current->y+2,0.1);
  current->cur++;
  if(current->cur>10) {
    draw_string("_",current->x+2+(strlen(current->label)*get_font_width()),current->y+2,0.1);
  }
  if (current->cur>20) {
    current->cur=0;
  }
}

void set_inputbox_text(int win_id, int but_id, char *text) {
  C99InputBox *current=get_inputbox(win_id,but_id);
  strcpy(current->label,text);
}

char *get_inputbox_text(int win_id, int but_id) {
  C99InputBox *current=get_inputbox(win_id,but_id);
  return current->label;
}

/*void set_window_click(int id, window_click_callback onClick) {
  C99Window *current=get_window(id);
  current->onClick=onClick;
}*/