#include <string.h>
#ifdef DREAMCAST
#include <kos.h>
#include <GL/gl.h>
#else
#include <windows.h>
#include <GL\gl.h>
#endif
#include <malloc.h>
#include "window.h"
#include "font.h"

int next_label_id=0;

int c99_create_label(int win_id, int x, int y, char *label) {
  struct C99Window *current_win=get_window(win_id);
  struct C99Label *current=current_win->label_list;
  struct C99Label *prev=NULL;
  while(current) {
    prev=current;
    current=current->next;
  }
  current=(struct C99Label*)malloc(sizeof(struct C99Label));
  current->x=x;
  current->y=y;
  current->but_id=next_label_id;
  current->win_id=win_id;
  current->next=NULL;
  strcpy(current->label,label);
  if(prev) {
    prev->next=current;
  } else {
    current_win->label_list=current;
  }
  return next_label_id++;
}

C99Label *get_label(int win_id, int but_id) {
  C99Window *cur_win=get_window(win_id);
  C99Label *current=cur_win->label_list;

  while(current) {
    if(current->but_id==but_id) return current;
    current=current->next;
  }

  return NULL;
}

void c99_label_set_text(int win_id, int but_id, char *text) {
  C99Label *current=get_label(win_id,but_id); 
  strcpy(current->label,text);
}

void c99_draw_label(struct C99Label *current) {
  draw_string(current->label,current->x+2,current->y+2,0.1);
}
